<template>
  <div
    class="fr-select-group"
    :class="{
      'fr-select-group--error': error,
      'fr-select-group--disabled': disabled
    }"
  >
    <label
      v-if="!noLabel"
      class="fr-label"
      :for="name"
    >
      {{ displayLabel }}
    </label>
    <select
      :id="name"
      class="fr-select"
      :class="{ 'fr-select--error': error }"
      :name="name"
      :required="required"
      :aria-describedby="ariaDescribedby"
      :aria-labelledby="labelledBy"
      :disabled="disabled"
      @change="onChange"
      @input="$emit('update:modelValue', $event.target.value)"
      @invalid="onValidate"
    >
      <option
        v-for="[optionValue, optionLabel] in options"
        :key="optionValue"
        :value="optionValue"
        :selected="optionValue === modelValue"
        :disabled="disabledOptions.includes(optionValue)"
      >
        {{ optionLabel }}
      </option>
    </select>
    <input
      v-if="disabled"
      :name="name"
      :aria-describedby="ariaDescribedby"
      :value="modelValue"
      hidden
    />
    <div
      v-if="error"
      :id="errorId"
      class="fr-messages-group"
      aria-live="assertive"
    >
      <p class="fr-message fr-message--error">
        {{ error }}
      </p>
    </div>
  </div>
</template>

<script setup>
  const props = defineProps({
    label: { type: String, required: true },
    noLabel: { type: Boolean, default: false },
    labelledBy: { type: String, default: undefined },
    name: { type: String, required: true },
    required: { type: Boolean, default: false },
    options: { type: Map, required: true },
    modelValue: { type: String, default: '' },
    disabled: { type: Boolean, default: false },
    disabledOptions: { type: Array, default: () => [] }
  })

  const emit = defineEmits(['changeValue', 'update:modelValue'])

  const error = ref('')

  const errorId = computed(() => `${props.name}-error-desc-error`)
  const displayLabel = computed(() =>
    props.required ? `${props.label} *` : props.label
  )
  const ariaDescribedby = computed(() =>
    error.value ? errorId.value : undefined
  )

  function onChange({ target }) {
    emit('changeValue', target.value)
    onValidate({ target })
  }

  function onValidate({ target }) {
    error.value = target.validationMessage
  }
</script>
